/*
 * Copyright (c) Solexa   2004, 2005, 2006
 *               Illumina 2007
 * Author:       Klaus Maisinger
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */

#ifndef SEQUENCEDATA_H_
#define SEQUENCEDATA_H_

#include <string>
#include "ParameterTypes.h"

class SequenceData
{
private:
    std::string m_Filename;
public:
    SequenceData(const char filename[]);
    virtual ~SequenceData();
    int write(const unsigned char  * sequenceArray,
              const int              numClusters,
              const int              numCycles,
              const int              lane = 0,
              const int              tile = 0,
              const Position       * positions = 0);
    int read(unsigned char * sequenceArray,
             int             numClusters,
             int             numCycles);
};

int read_sequence_file(const char      filename[],
                       unsigned char * sequence_array,
                       const int       numClusters,
                       const int       numCycles);
int write_sequence_file(const char          filename[],
                        const unsigned char *sequence_array,
                        const int            numClusters,
                        const int            numCycles,
                        const int            lane = 0,
                        const int            tile = 0,
                        const Position      *positions = 0);

#endif /*SEQUENCEDATA_H_*/
