// -*- c++ -*-
/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software 
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#ifndef TILE_LIST_H
#define TILE_LIST_H

/*****************************************************************************/

#include <string>
#include <list>

/*****************************************************************************/

class Tile_List
{
 public:
    Tile_List(const std::string& tile_list_file_path_str="tiles.txt");
    ~Tile_List();

    typedef std::list<std::string> Tile_Name_List;
    typedef Tile_Name_List::const_iterator Tile_Name_List_CIter;

    bool find_tiles(const std::string& search_prefix_str,
                    Tile_Name_List& tile_name_list,
                    const std::string& suffix_to_append_str = "");

 private:
    bool load();

    std::string my_tile_list_file_path_str;
    Tile_Name_List my_full_tile_name_list;
    bool my_list_is_loaded;
};

/*****************************************************************************/

#endif // ! TILE_LIST_H

/*****************************************************************************/
