#include <iostream>
#include <sstream>

using namespace std;

#include "testAutoGzFile.hh"

CPPUNIT_TEST_SUITE_REGISTRATION( TestAutoGzFile );

void TestAutoGzFile::setUp()
{
    fileName = "testAutoGzFile.fz";
    readMode = "r";
    writeMode = "w6R";
    s1="1234567890\n";
    std::ostringstream os(s2);
    for (unsigned int i = 0; i < 2000; ++i) os << i << ' ';
    os << std::endl;
    s2 = os.str();
    s3="\n";
    s4="";

}

void TestAutoGzFile::tearDown()
{
}

void TestAutoGzFile::testConstructor()
{
    IoUtils::AutoGzFile fh(fileName, writeMode);
    CPPUNIT_ASSERT (Z_NULL != fh);
}

void TestAutoGzFile::testWrite()
{
    IoUtils::AutoGzFile fh(fileName, writeMode);
    CPPUNIT_ASSERT_EQUAL(s1.length(), (size_t)fh.puts(s1));
    CPPUNIT_ASSERT_EQUAL(s2.length(), (size_t)fh.puts(s2));
    CPPUNIT_ASSERT_EQUAL(s3.length(), (size_t)fh.puts(s3));
    CPPUNIT_ASSERT_EQUAL(s4.length(), (size_t)fh.puts(s4));
}

void TestAutoGzFile::testRead()
{
    IoUtils::AutoGzFile fh(fileName, readMode);
    CPPUNIT_ASSERT_EQUAL(s1, fh.getline());
    CPPUNIT_ASSERT_EQUAL(s2, fh.getline());
    CPPUNIT_ASSERT_EQUAL(s3, fh.getline());
    CPPUNIT_ASSERT_EQUAL(s4, fh.getline());
}
