/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#include <string>
#include <iostream>

#include "Tile_List.h"

/*****************************************************************************/

int main()
{
    Tile_List tile_list("./tiles.txt");

    Tile_List::Tile_Name_List tile_name_list;

    const std::string search_prefix_str("s_3");
    const std::string suffix_to_append_str("_1_qval.txt");

    if (tile_list.find_tiles(search_prefix_str, tile_name_list,
                             suffix_to_append_str)) {
        std::cout << "The following tiles in the list matched `"
                  << search_prefix_str << "' :-" << std::endl;

        for (Tile_List::Tile_Name_List_CIter
                 tile_name_citer(tile_name_list.begin());
             tile_name_citer != tile_name_list.end(); ++tile_name_citer) {
            std::cout << " " << *tile_name_citer;
        }

        std::cout << std::endl;
    } else {
        std::cout << "Failure when attempting to find tiles." << std::endl;
    }

    return 0;
}

/*****************************************************************************/
