/*****************************************************************************/
// Copyright (c) Illumina 2008
// Author: Richard Shaw
// This source file is covered by the Illumina Genome Analyzer Software
// License Agreement and bound by the terms therein.
/*****************************************************************************/

#include "Message.h"

#include "option_test_utils.h"

/*****************************************************************************/

bool check_opt_arg_match(Opt_Arg_Map& opt_arg_map,
                         const std::string& opt_name,
                         const std::string& found_str)
{
    if (found_str != opt_arg_map[opt_name]) {
        error("Expected `%s' but found `%s' for option `%s'.",
              opt_arg_map[opt_name].c_str(), found_str.c_str(),
              opt_name.c_str());
        return false;
    }

    return true;
}

/*****************************************************************************/
