/****************************************************************************
File:        Filterer.h
Description: Include file for filtering using Mexican hats.
Created:     02/09/07  Saibal Banerjee

Copyright (c) 2007-2017, Illumina, All rights reserved.
This information is protected by copyright law and international
treaties.  Unauthorized reproduction or distribution of this file, or
any portion of it, may result in severe civil and criminal penalties,
and will be prosecuted to the maximum extent possible under the law.
****************************************************************************/

#ifndef FILTERER_H
#define FILTERER_H

#include "Sombrero.h"
#include "SmartImage.h"

class CFilterer
{
public:
    // Default Constructor
    CFilterer()
    : m_pSombrero(0)
    , m_iStatus(OKAY)
    {};

    // Run Function
    int Run(const float            fSigma,
            const int              iPicWidth,
            const int              iPicHeight,
            const unsigned short * pPicBuffer);

    // Destructor
    virtual ~CFilterer();

    const CFloatImage & GetPicture() const;

private:
    CSombrero * m_pSombrero;
    CFloatImage m_Picture;
    CFloatImage m_SubPicture;
    int         m_iStatus;
};

/* ******* */
/* Inlines */
/* ******* */
inline const CFloatImage & CFilterer::GetPicture() const {return m_Picture;}

#endif  // FILTERER_H
