/****************************************************************************
File:        GaussianFilter.h
Description: Include file for Gaussian filters.
Created:     12/17/03  SBanerjee

Copyright (c) 1996-2006, Saibal Banerjee, All rights reserved.
This information is protected by copyright law and international
treaties.  Unauthorized reproduction or distribution of this file, or
any portion of it, may result in severe civil and criminal penalties,
and will be prosecuted to the maximum extent possible under the law.
****************************************************************************/

#ifndef GAUSSIANFILTER_H
#define GAUSSIANFILTER_H

class CGaussianFilter
{
public:
    // Constructor
    CGaussianFilter()
        : m_fSigma(0)
        , m_iSize(0)
        , m_pBlur(0)
    {};

    // Constructor
    CGaussianFilter(const float fSigma);

    // Destructor
    virtual ~CGaussianFilter();

    // Accessors for member functions
    float   GetFilterSigma()        const;
    int     GetArraySize()          const;
    float * GetBlurArray()          const;
    float   Get2DBlurSumOfSquares() const;

private:
    float   m_fSigma;
    int     m_iSize;
    float * m_pBlur;
};

/* ******* */
/* Inlines */
/* ******* */
inline float   CGaussianFilter::GetFilterSigma() const {return m_fSigma;}
inline int     CGaussianFilter::GetArraySize()   const {return m_iSize;}
inline float * CGaussianFilter::GetBlurArray()   const {return m_pBlur;}

#endif // GAUSSIANFILTER_H
