/****************************************************************************
File:        Sombrero.h
Description: Include file for Mexican Hat filters.
Created:     02/09/07  Saibal Banerjee

Copyright (c) 2007-2017, Illumina, All rights reserved.
This information is protected by copyright law and international
treaties.  Unauthorized reproduction or distribution of this file, or
any portion of it, may result in severe civil and criminal penalties,
and will be prosecuted to the maximum extent possible under the law.
****************************************************************************/

#ifndef SOMBRERO_H
#define SOMBRERO_H

class CSombrero
{
public:
    // Constructor
    CSombrero()
        : m_fSigma(0)
        , m_iSize(0)
        , m_pAdd(0)
        , m_pSub(0)
    {};

    // Constructor
    CSombrero(const float fSigma);

    // Destructor
    virtual ~CSombrero();

    // Accessors for member functions
    float   GetFilterSigma() const;
    int     GetArraySize()   const;
    float * GetAddArray()    const;
    float * GetSubArray()    const;

private:
    float   m_fSigma;
    int     m_iSize;
    float * m_pAdd;
    float * m_pSub;

    void deallocate();
};

/* ******* */
/* Inlines */
/* ******* */
inline float   CSombrero::GetFilterSigma() const {return m_fSigma;}
inline int     CSombrero::GetArraySize()   const {return m_iSize;}
inline float * CSombrero::GetAddArray()    const {return m_pAdd;}
inline float * CSombrero::GetSubArray()    const {return m_pSub;}

#endif // SOMBRERO_H
