/*
 * Copyright (c) Illumina 2007
 * Author:       Klaus Maisinger
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */
#ifndef IMAGEREGIONLIST_H_
#define IMAGEREGIONLIST_H_

#include <vector>
#include "ParameterTypes.h"

class ImageRegionList
{
    int m_XDim;
    int m_YDim;
    std::vector<ImageRegion> m_Regions;
public:
    ImageRegionList(const int nx,
                    const int ny);
    void setRegionSizes(const int sizeX,
                        const int sizeY);
    void setNumRegions(const int numXRegion,
                       const int numYRegion);
    void getRegions(std::vector<ImageRegion> & regions);
    int  getNumRegions();
    int *getRegionIndex(Position * position, int numObjects);
    virtual ~ImageRegionList();
};

#endif /*IMAGEREGIONLIST_H_*/
