/*
 * Copyright (c) Solexa 2006
 * Author:
 * Klaus Maisinger
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */
#ifndef IMAGEXMLHANDLER_H_
#define IMAGEXMLHANDLER_H_

#include "XMLContentHandler.h"

class TestXMLHandler : public XMLContentHandler
{
public:
    TestXMLHandler() : XMLContentHandler() {};
    virtual ~TestXMLHandler() {};
    virtual void startDocument();
    virtual void startElement(const char name[], const Attributes *attr = 0);
    virtual void endElement(const char name[]);
    virtual void endDocument();
    virtual void characters(const char ch[], int start, int length);
};

class ImageXMLWriter : public XMLFileWriter
{
    int indentCurrent;
    int firstLine;
    void adjustWhitespace();
public:
    ImageXMLWriter();
	ImageXMLWriter(const char filename[], int indentLevel = 0);
	virtual ~ImageXMLWriter();
    void setFilename(const char filename[]);
    void setIndentLevel(int indentLevel = 0) { indentCurrent = indentLevel; }
    void writeElementFloat(const char name[], float element);
    void writeElementInt(const char name[], int element);
    void writeElementString(const char name[], const char element[]);
    void writeElementChar(const char name[], char element);
    virtual void startElement(const char name[], const Attributes *attr = 0);
    virtual void endElement(const char name[]);
    virtual void startDocument();
    virtual void endDocument();
};

#endif /*IMAGEXMLHANDLER_H_*/
