/*
 * Copyright (c) Solexa 2006
 * Author:
 * Klaus Maisinger
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */
#ifndef IMAGEXMLREADER_H_
#define IMAGEXMLREADER_H_

#include "XMLContentHandler.h"

class ImageXMLReader : public XMLContentHandler
{
    int inImage, inDeblocked, inExposure, inBase;
    int index;
    int is_deblocked[4];
    float exposure_times[4];
    unsigned char bases[4];
public:
	ImageXMLReader();
	virtual ~ImageXMLReader();
    virtual void startDocument();
    virtual void startElement(const char name[], const Attributes *attr = 0);
    virtual void endElement(const char name[]);
    virtual void characters(const char ch[], int start, int length);
    int getCount() { return index; }
    float *getExposureTimes() { return exposure_times; }
    unsigned char *getBases() { return bases; }
    int *getDeblocked() { return is_deblocked; }
};

#endif /* IMAGEXMLREADER_H_*/
