/*
 * Copyright (c) 2006 Solexa Ltd.
 * Author: Lorenzo Milazzo
 *
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 *
 */

#ifndef __DISTRIB_ADEQUACY_H__
#define __DISTRIB_ADEQUACY_H__


//
// structure 'args_ks'
// structure which contains the arguments for the function 'KSStatisticFunc()';
// - arguments:
//   no_el1   number of elements of the distribution 1
//   no_el2   number of elements of the distribution 2
//   data1    distribution 1 (reference distr.)
//   data2    distribution 2
//   p_func   pointer to the function 'scaledCumulDistrFunc()'
//
struct args_ks {
    int no_el1;
    int no_el2;
    float *data1;
    float *data2;
    float (*p_func) (float, float, float *, int);
};

static float maxarg_1, maxarg_2;

#define FMAX(a,b) (maxarg_1=(a),maxarg_2=(b),(maxarg_1) > (maxarg_2) ? (maxarg_1) : (maxarg_2))

int getIndex(float data1_el_s, float *data2, int no_el2);
float scaledCumulDistrFunc(float x, float data1_el, float *data2, int no_el2);
float KSStatisticFunc(float x, void *p_args_ks_v);


#endif /* __DISTRIB_ADEQUACY_H__ */
