/*
 * Copyright (c) 2006 Solexa Ltd.
 * Author: Lorenzo Milazzo
 *
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */

//
// CVS - $Id: lav_estimation.cpp,v 1.2 2008/03/28 13:18:11 km Exp $
//

#include <cmath>

#include "lav_estimation.h"


//
// LAV function
// (Least Absolute Values, L1 norm)
//
// x = slope of the fitting line (independent variable)
// l1_norm = l1 norm
//
float LAVFunc(float x, void *p_args_lav_v)
{
    float l1_norm;
    struct args_lav *p1;


    l1_norm = 0.0;

    p1 = (struct args_lav *)p_args_lav_v;

    for (int i = 0; i < p1->no_el; i++) {
        l1_norm += fabs(x * p1->data_x[i] - p1->data_y[i]);
    }

    return (l1_norm);


}
