/*
 * Copyright (c) 2006-2007 Solexa
 * Author: Lorenzo Milazzo
 *
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */

#ifndef __SAMPLING_H__
#define __SAMPLING_H__

#include "savinio_common.h"

struct MatrixSamplingParameters {
    int   numBins;
    float percentileXUpper;
    float percentileXLower;
    float percentageXUpper;
    float percentageXLower;
    float percentileY;
    MatrixSamplingParameters() : numBins(NO_BINS),
                                 percentileXUpper(PERCENTILE_UPPER_X_S1),
                                 percentileXLower(PERCENTILE_LOWER_X_S1),
                                 percentageXUpper(PERCENTAGE_UPPER_X_S1_ITER2),
                                 percentageXLower(PERCENTAGE_LOWER_X_S1_ITER2),
                                 percentileY(PERCENTILE_LOWER_Y_S1_ITER2)
                                 {};
};

void sampling1(const int     base_index,
               const int     no_points,
               const int     no_cols,
               const float * i_data,
               float       * xaxis_data,
               float       **yaxis_data,
               const MatrixSamplingParameters params);
void sampling2(const float * i_data,
               const int     no_points,
               const int     no_cols,
               float       * i_data_bA,
               float       * i_data_bC,
               float       * i_data_bG,
               float       * i_data_bT,
               int         & no_i_values_bA,
               int         & no_i_values_bC,
               int         & no_i_values_bG,
               int         & no_i_values_bT);
void sampling3(const float *i_data_i,
               const int    no_i_values_i,
               float      * i_data_f,
               int        & no_i_values_f);


#endif /* __SAMPLING_H__ */
