/*
 * Copyright (c) 2006-2007 Solexa
 * Author: Lorenzo Milazzo
 *
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */


#include <iostream>

#include "savinio_common.h"
#include "savinio_exceptions.h"
#include "Message.h"


Exception01::Exception01(const char *input_file, int no_objects)
{
    in_file   = input_file;
    n_objects = no_objects;
}

int Exception01::getNumberObjects()
{
    return n_objects;
}

void Exception01::display(void)
{
    char str1 [10];

    sprintf(str1, "%d", n_objects);

    error_msg.append("Validation checks on input: the no. of clusters detected is too low\n");
    error_msg.append("(intensity input file: ");
    error_msg.append(in_file);
    error_msg.append("; no. of clusters: ");
    error_msg.append(str1); 
    error_msg.append(")");
    warning(error_msg.c_str());
}


Exception02::Exception02()
{
   error_msg.append("The scaling of the cross-talk matrix failed");
}

void Exception02::display(void)
{
    warning(error_msg.c_str());
}
