/*  Time-stamp: <26 Jun 2006 17:03 BST plot.h km> */
/*
 * Copyright (c) Solexa 2006
 * Author:
 * Klaus Maisinger
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */

#ifndef _PLOT_H
#define _PLOT_H

#ifndef FTYPE
#define FTYPE double
#endif

#ifdef __cplusplus
extern "C" {
#endif
    void set_plot_labels(char xlabel[], char ylabel[], char title[]);
    void set_plot_contrast(FTYPE contrast);
    void set_plot_window(FTYPE xmin, FTYPE xmax, FTYPE min, FTYPE max);
    void plot_2d_array_slice(FTYPE * image, int nx, int ny,
                             FTYPE cellx, FTYPE celly, int zval, int icolor,
                             FTYPE min, FTYPE max, int wedge);
    void plot_2d_array(FTYPE * image, int nx, int ny, FTYPE cellx,
                       FTYPE celly, int icolor, FTYPE min, FTYPE max);
    void plot_3d_array(FTYPE * image, int nz, int nx, int ny, int samescale,
                       int color);
    void plot_points(FTYPE * x, FTYPE * xerr, FTYPE * y, FTYPE * yerr, int n,
                     int color);
    void plot_line(FTYPE * x, FTYPE * y, int n, int color);
    void plot_histogram(FTYPE * data, int n_data, FTYPE dmin, FTYPE dmax,
                        int n_bins, int color, int usewindow);
    void plot_poisson(FTYPE mean, FTYPE scale, int color);
    void plot_gaussian(FTYPE mean, FTYPE sigma, FTYPE scale,
                       FTYPE shift, int color);
    void plot_2d_wt_domains(int nx, int ny, FTYPE cellx, FTYPE celly,
                            int *i1, int *j1, int *i2, int *j2, int n);

#ifdef __cplusplus
}
#endif
#endif
