/*
 * Copyright (c) Solexa 2005, 2006
 * Author: Klaus Maisinger
 * This source file is covered by the "Illumina Genome Analyzer
 * Software License Agreement" and bound by the terms therein.
 */

#ifndef _MATHS_H
#define _MATHS_H

namespace Maths {
    const double pi   = 3.1415926535897931;
    const float  tiny = 1.e-12;

    template <class T>
    inline T max(const T & x, const T & y) {
        return (x > y ? x : y);
    }
    template <class T>
    inline T min(const T & x, const T & y) {
        return (x < y ? x : y);
    }
}

#define MAX(x, y) ((x) > (y) ? (x) : (y))
#define MIN(x, y) ((x) < (y) ? (x) : (y))
#define PI 3.1415926535897931

#endif
