#ifndef CLUSTER_LOCATION
#define CLUSTER_LOCATION

template<class CoordinateT>
class ClusterLocation
{
public:
    ClusterLocation(const CoordinateT &x, const CoordinateT &y, const unsigned int id)
        : x_(x), y_(y), id_(id)
    {}
    ClusterLocation() {}
    ClusterLocation(const ClusterLocation<CoordinateT> &clusterLocation)
        : x_(clusterLocation.x_), y_(clusterLocation.y_), id_(clusterLocation.id_)
    {}
    inline const CoordinateT &getX() const {return x_;}
    inline const CoordinateT &getY() const {return y_;}
    inline const unsigned int &getId() const {return id_;}
private:
    CoordinateT x_;
    CoordinateT y_;
    unsigned int id_;
};

#include <iostream>
template<class CoordinateT>
std::ostream &operator<<(std::ostream &os, const ClusterLocation<CoordinateT> &clusterLocation)
{
    return os << clusterLocation.getId() << "\t" << clusterLocation.getX() << "\t" << clusterLocation.getY();
}

#endif // #ifndef CLUSTER_LOCATION

