#ifndef QHG_FILTER
#define QHG_FILTER

#include <stdexcept>

#include "QhgParameters.hh"

class UnsupportedQhgFilter : public std::invalid_argument
{
public:
    UnsupportedQhgFilter(const std::string &message) : std::invalid_argument(message) {}
};

// The base pure virtual class for all Qhg Filters. 
// The operator () returns TRUE when the QhgParameters PASS the test.
class QhgFilter
{
public:
    virtual bool operator()(const QhgParameters &) const = 0;
    virtual ~QhgFilter() {}
protected:
    float threshold_;
private:
    friend const QhgFilter &getQhgFilter(const std::string &accessor, const std::string &comparator, float threshold) throw (UnsupportedQhgFilter);
};

const QhgFilter &getQhgFilter(const std::string &accessor, const std::string &comparator, float threshold) throw (UnsupportedQhgFilter);

#endif // #define QHG_FILTER

