#include <iostream>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <vector>
#include <utility>

#include "../ClusterLocation.hh"
#include "../ClusterNeighborhood.hh"

using namespace std;
typedef ClusterLocation<int> Location;
typedef vector<Location> LocationList;
typedef LocationList::const_iterator LocationIterator;

class Tile : public vector<ClusterLocation<int> >
{
public:
    const static int xMax = 1000;
    const static int yMax = 1000;
    Tile() : vector<ClusterLocation<int> >(200000)
    {
        for( iterator cluster = begin(); cluster != end(); ++cluster)
        {
            const int x = rand()%xMax;
            const int y = rand()%yMax;
            const int id= cluster - begin();
            *cluster = Location(x, y, id);
        }
    }
};

int main()
{
    const int radius = 10;
    const Tile tile = Tile();
    vector<int> binSizeList;
    binSizeList.push_back(1);
    binSizeList.push_back(2);
    binSizeList.push_back(3);
    //binSizeList.push_back(4);
    //binSizeList.push_back(5);
    //binSizeList.push_back(6);
    //binSizeList.push_back(7);
    //binSizeList.push_back(8);
    //binSizeList.push_back(9);
    //binSizeList.push_back(10);
    //binSizeList.push_back(11);
    //binSizeList.push_back(12);
    //binSizeList.push_back(13);
    //binSizeList.push_back(14);
    //binSizeList.push_back(15);
    //binSizeList.push_back(16);
    //binSizeList.push_back(17);
    //binSizeList.push_back(18);
    //binSizeList.push_back(19);
    //binSizeList.push_back(20);
    cout << "starting " << endl;
    for (vector<int>::const_iterator binSize = binSizeList.begin(); binSize != binSizeList.end(); ++binSize)
    {
        LocationList t(tile.begin(), tile.end());
        const Cluster::Neighborhood::Finder<int> finder(t, pair<int, int>(radius, radius));
        LocationList neighborhood;
        neighborhood.reserve(100000);
        vector<LocationList> neighborhoodList(tile.size());
        ostringstream fileName;
        fileName << "test_qhg_";
        //fileName <<  *binSize;
        fileName << setw(2) << *binSize;
        //fileName << setw(3) << setfill(0) << *binSize;
        fileName << ".txt";
        ofstream os;
        os.open(fileName.str().c_str() );
        const clock_t start = clock();
        int tt = 1;
        for (LocationIterator cluster = t.begin(); cluster != t.end(); ++cluster)
        {
            finder.getNeighborhood(cluster, radius, neighborhood);
            os << "1\t2\t" << (cluster->getX()) << "\t" << (cluster->getY()) << "\t";
            if (!neighborhood.empty()) 
            {
                //os << neighborhood[0].getId();
                //for(unsigned int i = 1; i != neighborhood.size(); ++i) os << ':' << neighborhood[i].getId();
                 tt ^= neighborhood[0].getId();
                for(unsigned int i = 1; i != neighborhood.size(); ++i) tt^= neighborhood[i].getId();
            }
            else
            {
                //os << "-1";
                tt ^= -1;
            }
            //os << "\n";
        }
        os << tt;
        os.close();
        cout << setw(2) << *binSize << ": " << (clock() - start)/1000 <<  "ms" << endl;
    }
}
