/*
 * Copyright (c) Solexa 2006
 * Author: Klaus Maisinger
 * This source file is covered by the "Solexa Public Source License"
 * agreement and bound by the terms therein.
 */
#include <string>
#include <iostream>
#include "ReadParams.h"

DataSet::DataSet() {}

DataSet::~DataSet() {}

int DataSet::getNumberParameters() const
{
    return values.size();
}

int DataSet::getNumberValues() const
{ 
    if (values.size() > 0)
        return values[0].size();
    return 0;
}
    
std::vector<float> *DataSet::getParameterValues(int idx)
{
    return & (values[idx]);
}

void DataSet::addParameterValues(std::vector<float> &new_values)
{
    values.push_back(new_values);
}

std::vector<std::vector<float> > *DataSet::getParameterValues()
{
    return &values;
} 

std::vector<BaseAlignment> *DataSet::getBaseReads()
{
    return & (reads);
}
